CREATE TABLE Ksiazki
(
  `Id` INTEGER AUTO_INCREMENT PRIMARY KEY,
  `WydawnictwoId` INTEGER NOT NULL,
  `Tytu` VARCHAR(45) NOT NULL,
  `ISBN` VARCHAR(13),
  `Rok wydania` YEAR,
  `Opis` TEXT,
  `Cena` DECIMAL(6,2)
);

CREATE TABLE Autorzy
(
  `Id` INTEGER AUTO_INCREMENT PRIMARY KEY,
  `Nazwa` VARCHAR(45) NOT NULL
);

CREATE TABLE KsiazkiAutorzy
(
  `KsikaId` INTEGER NOT NULL,
  `AutorId` INTEGER NOT NULL,
  PRIMARY KEY(`KsikaId`, `AutorId`)
);

CREATE TABLE Wydawnictwa
(
  `Id` INTEGER AUTO_INCREMENT PRIMARY KEY,
  `Nazwa` VARCHAR(45) NOT NULL,
  `Adres` VARCHAR(60)
);

CREATE TABLE Klienci
(
  `Id` INTEGER AUTO_INCREMENT PRIMARY KEY,
  `Imi` VARCHAR(45) NOT NULL,
  `Nazwisko` VARCHAR(45) NOT NULL,
  `Ulica` VARCHAR(45) NOT NULL,
  `Nr domu` VARCHAR(5) NOT NULL,
  `Nr mieszkania` VARCHAR(5),
  `Miasto` VARCHAR(45) NOT NULL,
  `Kod` VARCHAR(6) NOT NULL,
  `Kraj` VARCHAR(30) NOT NULL
);

CREATE TABLE Zamowienia
(
  `Id` INTEGER AUTO_INCREMENT PRIMARY KEY,
  `KlientId` INTEGER NOT NULL,
  `Data wprowadzenia` DATETIME NOT NULL,
  `Data realizacji` DATE,
  `Status` INTEGER NOT NULL
);

CREATE TABLE KsiazkiZamowienia
(
  `KsikaId` INTEGER NOT NULL,
  `ZamwienieId` INTEGER NOT NULL,
  `Ilo` INTEGER NOT NULL,
  `Cena` DECIMAL(6,2) NOT NULL,
  PRIMARY KEY(`KsikaId`, `ZamwienieId`)
);

CREATE TABLE Opinie
(
  `Id` INTEGER AUTO_INCREMENT PRIMARY KEY,
  `KsikaId` INTEGER NOT NULL,
  `KlientId` INTEGER NOT NULL,
  `Ocena` ENUM ('1', '2', '3', '4', '5', '6'),
  `Opinia` TEXT
);

CREATE TABLE Recenzje
(
  `Id` INTEGER AUTO_INCREMENT PRIMARY KEY,
  `KsikaId` INTEGER NOT NULL,
  `Autor` VARCHAR(45),
  `rdo` VARCHAR(45),
  `Recenzja` TEXT NOT NULL
);

CREATE TABLE AutorzyPseudonimy
(
  `AutorId1` INTEGER NOT NULL,
  `AutorId2` INTEGER NOT NULL,
  PRIMARY KEY(`AutorId1`, `AutorId2`)
);
